%%  FSP Example 1: Birth Death.
%% Birth Death process, approach 1.
close all
clear all
eps_min = 1e-6;     % Minimum allowable error
k = 50;             % Transcription rate
g = 1;              % Degradation rate

N = 10;             % First guess of the max number of RNA.
eps = 1;            % Current error.
tf = 1;             % final time

k2 = 1;

tic
% for tf = linspace(0,1,20);
    eps = 1;            % Current error.
    while  eps>eps_min
        Pinit = spalloc(N+2,1,1);   % Initialize probability distribution.
        Pinit(1) = 1;
        
        %% Using for loops (SLOW)
        A = spalloc(N+2,N+2,(N+2)*3);
        
        
        for i=0:N
            k = 300+1000*i^10/(205^10+i^10);
%             if i<N
                A(i+1,i+1) =  -k -k2 - g*i;   % Flow out.
%             else
%                 A(i+1,i+1) = - g*i;   % Flow out.
%             end
            
            A(i+2,i+1) = k;                      % Flow out due to production
            A(min(i+3,N+2),i+1) = k2;                      % Flow out due to production
            if i>=1
%                 A(i+1,i+1) =  -k - g*i;   % Flow out.
                A(i,i+1) = g*i;                % Flow out due to degradation
            end
        end
        
        %% Using EXPM (SLOW)
        %     Pf = expm(A*tf)*Pinit;
        
        %% Using Expokit (Faster)
        Pf = mexpv(tf,A,Pinit);
        
        eps = Pf(end);
        if eps>eps_min
            N=ceil(N*2);
            %         N=ceil(N+1);
        end
    end
    toc
    
    plot([0:N],Pf(1:end-1),'b')
    hold on
    drawnow
%     Y = pdf('poiss',[0:N],k/g*(1-exp(-g*tf)));
%     plot([0:N],Y,'r--')
% end


return
%%
g=[];
Tar = logspace(-4,0,200);
for t=Tar
    P = expm(A*t)*Pinit;
    g=[g;P(end)];
end
plot(Tar,g)


