%%  FSP Example 1: Birth Death.
%% Birth Death process, approach 1.
close all
clear all
eps_min = 1e-6;     % Minimum allowable error
k = 50;             % Transcription rate
g = 1;              % Degradation rate

N = 10;             % First guess of the max number of RNA.
eps = 1;            % Current error.
tf = 1;             % final time

while  eps>eps_min 
    Pinit = spalloc(N+2,1,1);   % Initialize probability distribution.
    Pinit(1) = 1;               

    %% Using for loops (SLOW)
    A = spalloc(N+2,N+2,(N+2)*3);
    for i=0:N        
        A(i+1,i+1) = A(i+1,i+1) - k - g*i;   % Flow out.
        A(i+2,i+1) = k;                      % Flow out due to production
        if i>=1
            A(i,i+1) = g*i;                % Flow out due to degradation
        end
    end
    
    %% Using EXPM (SLOW)
%     Pf = expm(A*tf)*Pinit;
    
    %% Using Expokit (Faster)
    Pf = mexpv(tf,A,Pinit);
    
    eps = Pf(end);   
    if eps>eps_min
        N=ceil(N*1.1);
    end
end

plot([0:N],Pf(1:end-1),'b')
hold on
Y = pdf('poiss',[0:N],k/g*(1-exp(-g*tf)));
plot([0:N],Y,'r--')



